unit uMD00DtoMD00U;{ .MD00u}
interface
type string6=string[6]; string255=string[255];

{CodeProc=0} procedure Code0;
{CodeProc=1#}procedure SetAddrRAM(e:Cardinal);
{CodeProc=2#}procedure DB(e:Cardinal);
{CodeProc=3#}procedure StartProgram;
{CodeProc=4}procedure INITCompiler;
{CodeProc=5#}Function FINALCompiler:Boolean;
{CodeProc=6}procedure REM(S:string255);
{CodeProc=7}procedure SetNameInternal(s:string6);
{CodeProc=8#}procedure FillChar(Count,e:Cardinal);
{CodeProc=9#}Procedure ComA(COM:Cardinal);
{CodeProc=10#}Procedure ComB(COM,Value:Cardinal);
{CodeProc=11#}Procedure ComC(COM,Value:Cardinal);
{CodeProc=12#}procedure FillDB(var arr:array of Byte; BeginPos, count:Cardinal);
{CodeProc=13}procedure SetFullNameLVTfile(s:string255);
{CodeProc=14}procedure SetfSaveLVT(b:Boolean);
{CodeProc=15}procedure SetfSE(b:Boolean);
{CodeProc=16}procedure SetCLU(s:string255);
{CodeProc=17}procedure SetfCLU(b:Boolean);
{CodeProc=18}procedure SetfSEi(b:Boolean);
{CodeProc=19}procedure SetNameInternalKOI(s:string6);
{CodeProc=20}procedure SetFileOutError(s:string255);
{CodeProc=21}procedure SetErrorCLU(s:string255);
{CodeProc=22}procedure SetfError(b:Boolean);
{CodeProc=23}procedure SetfErrorfCLU(b:Boolean);
{CodeProc=24}procedure SetfErrorTXTinFile(b:Boolean);

{CodeProc=28}procedure FillDW(var arr:array of Word;BeginPos,count:Cardinal);
{CodeProc=29}procedure DW(e:Cardinal);

{CodeProc=31}procedure RET_END;
{CodeProc=32}procedure FillDD(var arr:array of Cardinal;BeginPos,count:Cardinal);
{CodeProc=33}procedure DD(e:Cardinal);
{CodeProc=34}procedure FillDQ(var arr:array of int64;BeginPos,count:Cardinal);
{CodeProc=35}procedure DQ(e:int64);


implementation

var FMD00u:array[1..1000000] of Byte; SizeOfFMD00u:Cardinal;

Procedure addStrFMD00u(s:string255);{  string255  FMD00u}
var c,Lengths:Cardinal;
begin Lengths:=Length(s);
 If Lengths<>0 then Begin {$R-} for c:=1 to Lengths do FMD00u[SizeOfFMD00u+c]:=Ord(S[c]);{$R+}end;
SizeOfFMD00u:=SizeOfFMD00u+Lengths;end;

Procedure addStr0FMD00u(s:string255);{  string255  S[0]   FMD00u}
begin {  string[0] ..  s}SizeOfFMD00u:=SizeOfFMD00u+1;FMD00u[SizeOfFMD00u]:=ord(S[0]);
{ string} addStrFMD00u(s);end;

Procedure addByteFMD00u(B:Byte);{   FMD00u}begin SizeOfFMD00u:=SizeOfFMD00u+1;FMD00u[SizeOfFMD00u]:=b; end;
Procedure addWordFMD00u(W:Word);{ Word  FMD00u}begin FMD00u[SizeOfFMD00u+1]:=Lo(w);FMD00u[SizeOfFMD00u+2]:=Hi(w);SizeOfFMD00u:=SizeOfFMD00u+2; end;
Procedure addCardinalFMD00u(C:Cardinal);{ Cardinal  }var b4:array[1..4] of Byte;c1:Cardinal absolute b4;begin c1:=C; FMD00u[SizeOfFMD00u+1]:=b4[1];FMD00u[SizeOfFMD00u+2]:=b4[2];FMD00u[SizeOfFMD00u+3]:=b4[3];FMD00u[SizeOfFMD00u+4]:=b4[4];SizeOfFMD00u:=SizeOfFMD00u+4;end;
Procedure addInt64FMD00u(I64:Int64);{ Int64  }
var b8:array[1..8] of Byte;I64_1:Int64 absolute b8;
begin
I64_1:=I64;
FMD00u[SizeOfFMD00u+1]:=b8[1];FMD00u[SizeOfFMD00u+2]:=b8[2];FMD00u[SizeOfFMD00u+3]:=b8[3];
FMD00u[SizeOfFMD00u+4]:=b8[4];FMD00u[SizeOfFMD00u+5]:=b8[5];FMD00u[SizeOfFMD00u+6]:=b8[6];
FMD00u[SizeOfFMD00u+7]:=b8[7];FMD00u[SizeOfFMD00u+8]:=b8[8];SizeOfFMD00u:=SizeOfFMD00u+8;end;

procedure proc(code:Cardinal);Begin addByteFMD00u(code);end;
procedure procB(code:Cardinal;b:byte);Begin addByteFMD00u(code);addByteFMD00u(b);end;
procedure procW(code:Cardinal;w:word);Begin addByteFMD00u(code);addWordFMD00u(w);end;
procedure procC(code:Cardinal;c:Cardinal);Begin addByteFMD00u(code);addCardinalFMD00u(c);end;
procedure procQ(code:Cardinal;i64:int64);Begin addByteFMD00u(code);addInt64FMD00u(I64);end;
procedure procCB(code,c:Cardinal;b:byte);begin addByteFMD00u(code);addCardinalFMD00u(C);addByteFMD00u(b);end;
procedure procS255(code:Cardinal;s:string255); begin addByteFMD00u(code);addStr0FMD00u(S);end;
procedure procBB(code:Cardinal;b1,b2:byte);Begin addByteFMD00u(code);addByteFMD00u(b1);addByteFMD00u(b2);end;
procedure procBW(code:Cardinal;b:byte;w:word);Begin addByteFMD00u(code);addByteFMD00u(b);addWordFMD00u(w);end;
procedure procBool(code:Cardinal;b:Boolean);Begin addByteFMD00u(code);If b=True then addByteFMD00u(1) else addByteFMD00u(0);end;
procedure procCC(code,c1,c2:Cardinal);begin addByteFMD00u(code);addCardinalFMD00u(C1);addCardinalFMD00u(C2);end;

procedure WriteFileFMD00u(FS:string255);
var f:file; SizeOfBuf,NumRead:Cardinal; SizeOfSStr:Cardinal;
begin Filemode:=1; AssignFile(F,FS);  Rewrite(F,1);   Seek(f,0);
If SizeOfFMD00u <> 0 then begin BlockWrite(F,FMD00u,SizeOfFMD00u,NumRead); end;
CloseFile(F);end;


{CodeProc=0}procedure Code0;begin end;{ -}
{CodeProc=1#}procedure SetAddrRAM(e:Cardinal); begin procW(1,e);end;
{CodeProc=2#}procedure DB(e:Cardinal); begin procB(2,e);end;
{CodeProc=3#}procedure StartProgram; begin proc(3);end;
         {CodeProc=4}procedure INITCompiler_; begin proc(4);end;
procedure INITCompiler;{""   }
begin
{  }Begin SizeOfFMD00u:=0; addStrFMD00u('MD00u')end;
INITCompiler_;
end;
          {CodeProc=5#}Function FINALCompiler_:Boolean;begin proc(5);end;
Function FINALCompiler:Boolean;{""   }
begin
 FINALCompiler:=FINALCompiler_;
 RET_END;
{ }
WriteFileFMD00u('Project.MD00u');
end;

{CodeProc=6}procedure REM(S:string255);begin procS255(6,s);end;
{CodeProc=7}procedure SetNameInternal(s:string6);begin procS255(7,s);end;
{CodeProc=8#}procedure FillChar(Count,e:Cardinal);begin procCB(8,Count,e);end;
{CodeProc=9#}Procedure ComA(COM:Cardinal);begin procB(9,COM);end;
{CodeProc=10#}Procedure ComB(COM,Value:Cardinal);begin procBB(10,COM,Value);end;
{CodeProc=11#}Procedure ComC(COM,Value:Cardinal);begin procBW(11,COM,Value);end;


procedure Fill_(Nproc,Length_arr,BeginPos:Cardinal; var count:Cardinal);
var b:array[1..4]of byte; Card:Cardinal absolute b;
c1:Cardinal;
begin Card:=0;
If BeginPos<=Length_arr then begin  proc(Nproc);
 c1:=Length_arr-BeginPos;{c1 -   }  if c1 < count then count:=c1;
 Card:=count;
Case count of
0..255:begin addByteFMD00u(1);addByteFMD00u(b[1]);end;
256..65535:begin addByteFMD00u(2);addByteFMD00u(b[1]);addByteFMD00u(b[2]);end;
65536..16777215:begin addByteFMD00u(3);addByteFMD00u(b[1]);addByteFMD00u(b[2]); addByteFMD00u(b[3]);end;
16777216..4294967295:begin addByteFMD00u(4);addByteFMD00u(b[1]);addByteFMD00u(b[2]); addByteFMD00u(b[3]);addByteFMD00u(b[4]);end;
end;end;end;

{CodeProc=12#}procedure FillDB(var arr:array of Byte; BeginPos, count:Cardinal);
Var c:Cardinal;
begin If count<>0 then begin Fill_(12,Length(arr),BeginPos, count);
for c:=1 to Count do addByteFMD00u(arr[BeginPos+c-1]);end;end;

{CodeProc=13}procedure SetFullNameLVTfile(s:string255);begin procS255(13,s);end;
{CodeProc=14}procedure SetfSaveLVT(b:Boolean);begin procBool(14,b);end;
{CodeProc=15}procedure SetfSE(b:Boolean);begin procBool(15,b);end;
{CodeProc=16}procedure SetCLU(s:string255);begin procS255(16,s);end;
{CodeProc=17}procedure SetfCLU(b:Boolean);begin procBool(17,b);end;
{CodeProc=18}procedure SetfSEi(b:Boolean);begin procBool(18,b);end;
{CodeProc=19}procedure SetNameInternalKOI(s:string6);begin procS255(19,s);end;
{CodeProc=20}procedure SetFileOutError(s:string255);begin procS255(20,s);end;
{CodeProc=21}procedure SetErrorCLU(s:string255);begin procS255(21,s);end;
{CodeProc=22}procedure SetfError(b:Boolean);begin procBool(22,b);end;
{CodeProc=23}procedure SetfErrorfCLU(b:Boolean);begin procBool(23,b);end;
{CodeProc=24}procedure SetfErrorTXTinFile(b:Boolean);begin procBool(24,b);end;



{CodeProc=28}procedure FillDW(var arr:array of Word;BeginPos,count:Cardinal);
Var c:Cardinal;
begin If count<>0 then begin Fill_(28,Length(arr),BeginPos, count);
for c:=1 to Count do addWordFMD00u(arr[BeginPos+c-1]);end; end;
{CodeProc=29}procedure DW(e:Cardinal); begin procW(29,e); end;

{CodeProc=31}procedure RET_END;begin proc(31);end;
{CodeProc=32}procedure FillDD(var arr:array of Cardinal;BeginPos,count:Cardinal);
Var c:Cardinal;
begin If count<>0 then begin Fill_(32,Length(arr),BeginPos, count);
for c:=1 to Count do addCardinalFMD00u(arr[BeginPos+c-1]);end;end;
{CodeProc=33}procedure DD(e:Cardinal); begin procC(33,e); end;

{CodeProc=34}procedure FillDQ(var arr:array of int64;BeginPos,count:Cardinal);
Var c:Cardinal;
begin If count<>0 then begin Fill_(34,Length(arr),BeginPos, count);
for c:=1 to Count do addInt64FMD00u(arr[BeginPos+c-1]);end;end;
{CodeProc=35}procedure DQ(e:int64); begin procQ(35,e); end;


{CodeProc=0} Exports Code0;
{CodeProc=1#}Exports SetAddrRAM;
{CodeProc=2#}Exports DB;
{CodeProc=3#}Exports StartProgram;
{CodeProc=4}Exports INITCompiler;
{CodeProc=5#}Exports  FINALCompiler;
{CodeProc=6}Exports REM;
{CodeProc=7}Exports SetNameInternal;
{CodeProc=8#}Exports FillChar;
{CodeProc=9#}Exports ComA;
{CodeProc=10#}Exports ComB;
{CodeProc=11#}Exports ComC;
{CodeProc=12#}Exports FillDB;
{CodeProc=13}Exports SetFullNameLVTfile;
{CodeProc=14}Exports SetfSaveLVT;
{CodeProc=15}Exports SetfSE;
{CodeProc=16}Exports SetCLU;
{CodeProc=17}Exports SetfCLU;
{CodeProc=18}Exports SetfSEi;
{CodeProc=19}Exports SetNameInternalKOI;
{CodeProc=20}Exports SetFileOutError;
{CodeProc=21}Exports SetErrorCLU;
{CodeProc=22}Exports SetfError;
{CodeProc=23}Exports SetfErrorfCLU;
{CodeProc=24}Exports SetfErrorTXTinFile;

{CodeProc=28}exports FillDW;
{CodeProc=29}exports DW;

{CodeProc=31}Exports RET_END;
{CodeProc=32}exports FillDD;
{CodeProc=33}exports DD;
{CodeProc=34}exports FillDQ;
{CodeProc=35}exports DQ;

end.


